"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BigInteger = void 0;
/**
 * @author 田尘殇Sean(sean.snow@live.com) create at 2017/12/21
 */
class BigInteger extends Number {
    constructor(magnitude, signum) {
        super();
    }
    static valueOf(val) {
        if (Array.isArray(val)) {
            return val[0] > 0 ? new BigInteger(val, 1) : new BigInteger(val);
        }
        if (val === 0) {
            return BigInteger.ZERO;
        }
        if (val > 0 && val <= BigInteger.MAX_CONSTANT) {
            return BigInteger.posConst[val];
        }
        else if (val < 0 && val >= -BigInteger.MAX_CONSTANT) {
            return BigInteger.negConst[-val];
        }
        return new BigInteger(val);
    }
}
exports.BigInteger = BigInteger;
BigInteger.ZERO = new BigInteger([0], 0);
BigInteger.ONE = BigInteger.valueOf(1);
BigInteger.TEN = BigInteger.valueOf(10);
BigInteger.MAX_CONSTANT = 16;
BigInteger.posConst = [];
BigInteger.negConst = [];
