"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Arrays = void 0;
/**
 * @author Sean sean.snow@live.com
 * @date 2015/12/27
 */
class Arrays {
    static copyOf(original, newLength) {
        let copy = new Array(newLength);
        Arrays.arraycopy(original, 0, copy, 0, Math.min(original.length, newLength));
        return copy;
    }
    static arraycopy(src, srcPos, dest, destPos, length) {
        let tmp = src.slice(srcPos);
        for (let i = destPos; i < destPos + length; i++) {
            dest[i] = tmp[i - destPos];
        }
    }
    /**
     * 笛卡尔积
     */
    static cartesian(arr) {
        if (arr.length === 0) {
            return [];
        }
        if (arr.length === 1) {
            return arr[0].map(item => [item]);
        }
        return [].reduce.call(arr, function (col, set) {
            let res = [];
            col.forEach(c => {
                set.forEach(s => {
                    let t = [].concat(Array.isArray(c) ? c : [c]);
                    t.push(s);
                    res.push(t);
                });
            });
            return res;
        });
    }
}
exports.Arrays = Arrays;
